CREATE OR REPLACE PROCEDURE ATUALIZA_PARCMPSUP_PDR(
P_CDFILIAL FILIAL.CDFILIAL%TYPE
)
AS
   V_UPDATE_TEXT             VARCHAR2(10000);
   V_INSERT_TEXT             VARCHAR2(10000);
   V_CDFILIAL_PADRAO         FILIAL.CDFILIAL%TYPE;
   V_CDFILIAL                EMPRCNTRFIL.CDFILIAL%TYPE;
BEGIN
   BEGIN
      SELECT CDFILIPADRAO
        INTO V_CDFILIAL_PADRAO
        FROM PARAMGERAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDFILIAL_PADRAO := NULL;
   END;
  /*VERIFICA SE EXISTE FILIAL PADRAO PARAMETRIZADA*/
   IF V_CDFILIAL_PADRAO IS NOT NULL THEN
      /*SELECIONA TODAS AS FILIAIS QUE UTILIZAM A PARAMETRIZAO POR FILIAL PADRAO
        DA TABELA 'PARCMPSUP'*/
      FOR C_INSPARAM IN(SELECT CDFILIAL
                          FROM PARAMFILIPADR
                         WHERE IDTABPARAMFILI = 'S'
                           AND NMTABPARAMFILI = 'PARCMPSUP'
                           AND CDFILIAL <> V_CDFILIAL_PADRAO
                           AND CDFILIAL = NVL(P_CDFILIAL, CDFILIAL))
      LOOP
         V_UPDATE_TEXT := 'INSERT INTO PARCMPSUP (';
         V_INSERT_TEXT := '(SELECT ' ;
         /*APAGA AS EMPRESAS DA FILIAL QUE SERA PARAMETRIZADA*/
         DELETE FROM EMPRCNTRFIL WHERE CDFILIAL =  C_INSPARAM.CDFILIAL;
         /*CADASTRA EMRESAS NA FILIAL QUE SERA PARAMETRIZADA */
         SELECT MAX(CDFILIAL)
           INTO V_CDFILIAL
           FROM EMPRCNTRFIL
          WHERE CDFILIAL = V_CDFILIAL_PADRAO;
         IF V_CDFILIAL IS NOT NULL THEN
            INSERT INTO EMPRCNTRFIL (CDFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, CDSERIE)
                                    (SELECT C_INSPARAM.CDFILIAL, CDEMPRESA,
                                            CDINSCESTA, CDINSCMUNI, CDSERIE
                                       FROM EMPRCNTRFIL WHERE CDFILIAL  = V_CDFILIAL_PADRAO);
         END IF;
         /*SELECIONA OS NOMES DAS COLUNAS DAS TABELA 'PARCMPSUP'*/
         FOR C_CAMPO IN (SELECT COLUMN_NAME
                           FROM USER_TAB_COLUMNS
                          WHERE TABLE_NAME   = 'PARCMPSUP'
                            AND COLUMN_NAME <> 'CDFILIAL'
                          )
         LOOP
            V_UPDATE_TEXT := V_UPDATE_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
            V_INSERT_TEXT := V_INSERT_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
         END LOOP;
         /*DELETA OS PARAMETROS DA FILIAL
           QUE UTILIZA PARAMETRIZAO PELA PADRO*/
         DELETE FROM PARCMPSUP
          WHERE CDFILIAL = C_INSPARAM.CDFILIAL;
         V_UPDATE_TEXT := V_UPDATE_TEXT||'CDFILIAL) ';
         V_INSERT_TEXT := V_INSERT_TEXT||''''||C_INSPARAM.CDFILIAL||''''||' ';
         V_INSERT_TEXT := V_INSERT_TEXT ||'FROM PARCMPSUP ';
         V_INSERT_TEXT := V_INSERT_TEXT ||'WHERE CDFILIAL = '||''''||V_CDFILIAL_PADRAO||''''||') ';
         V_UPDATE_TEXT := V_UPDATE_TEXT || V_INSERT_TEXT;
         EXECUTE IMMEDIATE V_UPDATE_TEXT ;
      END LOOP;
      COMMIT;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_PARCMPSUP_PDR','5.07.006'); END;
/
