<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class FpaIncidevento extends \Doctrine\ORM\EntityRepository {
    
    public function retornaIncidencias($nrorg, $dtmescompetenc, $nrorgPadrao){
    
        $params = array('nrorg'=>$nrorg, 'nrorgpadrao'=>$nrorgPadrao, 'dtmescompetenc'=>$dtmescompetenc);
        $incideEvento = Repositories::FPA_INCIDEVENTO;
        
$sql = <<<SQL
    SELECT i FROM $incideEvento i
    WHERE i.dtmescompetenc =     
    (SELECT MAX(x.dtmescompetenc)
        FROM $incideEvento x
        WHERE x.dtmescompetenc <= :dtmescompetenc
        AND x.nrorg = i.nrorg        
    AND x.nreventom = i.nreventom 
    AND x.nrtipoincide = i.nrtipoincide)
    AND (i.nrorg = :nrorg or i.nrorg = :nrorgpadrao)
    ORDER BY i.nrtipoincide,i.nreventom
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaListaDissidio($nrorg, $dtmescompetenc, $nrorgPadrao){
        
        $ultimoDiaDoMes = DateUtil::getUltimoDiaDoMes($dtmescompetenc);
        $params = array('nrorg'=>$nrorg, 'nrorgpadrao'=>$nrorgPadrao, 'dtmescompetenc'=>$dtmescompetenc, 'ultimodiadomes'=>$ultimoDiaDoMes);
        $incideEvento = Repositories::FPA_INCIDEVENTO;
        $eventom = Repositories::FPA_EVENTOM;
        
$sql = <<<SQL
    select i.*
    from $incideEvento i
    join $eventom e on ( e.nrorg = :nrorgpadrao or e.nrorg = :nrorg )
                   and e.nreventom = i.nreventom
                   and e.dtinivigencia <= :ultimodiadomes
    where ( i.nrorg = :nrorgpadrao or i.nrorg = :nrorg )
    and i.dtmescompetenc = ( select max( dtmescompetenc )
                            from $incideEvento x
                            where x.nrorg        = i.nrorg
                              and x.nrtipoincide = i.nrtipoincide
                              and x.nreventom    = i.nreventom
                              and x.dtmescompetenc <= :dtmescompetenc )
    order by i.nrtipoincide, i.nreventom
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

}